/*******************************************************************************
 *
 * Copyright (c) 2016-2026 HYCON Technology, Inc.
 * All rights reserved.
 * HYCON Technology <www.hycontek.com>
 *
 * HYCON reserves the right to amend this code without notice at any time.
 * HYCON assumes no responsibility for any errors appeared in the code,
 * and HYCON disclaims any express or implied warranty, relating to sale
 * and/or use of this code including liability or warranties relating
 * to fitness for a particular purpose, or infringement of any patent,
 * copyright or other intellectual property right.
 *
 * -----------------------------------------------------------------------------
 * File Name    : user_sample.c
 * IDE tooling  : AndeSight C/C++ IDE, version: 2.0.1 Build ID : 201303201736
 * Device Ver.  : V0.9 crt0.o for HY16F19xx & HY16F18xx MCU.
 * Library Ver. : 1.1
 * MCU Device   : HY16F198B-L100 @3.0V
 * Description  : This file implements the customer's function.
 * Created Date : 2016/05/28
 * Created by   :
 *
 ******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Header file include                                                        */
/*----------------------------------------------------------------------------*/
//#include "stdint.h"
#include "HY16F198.h"
#include "System.h"
#include "DrvADC.h"
#include "DrvClock.h"
#include "DrvPMU.h"
#include "DrvGPIO.h"
#include "DrvLCD.h"
#include "DrvREG32.h"
#include "DrvRTC.h"
#include "DrvTimer.h"
#include "DrvUART.h"
#include "DrvFlash.h"
#include "ModuleID.h"
#include "SpecialMacro.h"
#include "Sysinfra.h"
#include "user_DEF.h"
#include "user_LCD.h"

#include "DrvCMP.h"
#include "DrvPMU.h"
/*----------------------------------------------------------------------------*/
/* Structure definition                                                       */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* Global variable definition                                                 */
/*----------------------------------------------------------------------------*/

unsigned int  Sleep_Time_Cnt;
unsigned char DisplayBuffer[18];
unsigned int  ADCbuffer[16];
unsigned int  ADC_RawData;
unsigned int  ADC_Avg_RawData;
unsigned int  FIR_SumBuf;
unsigned char FIR_Buf_Idx;
unsigned char Throw_Cnt;

unsigned char ADfinish;
unsigned char ADC_Count;

#define  Disable 0
#define  Enable  1
int threh0,threh1,threh2,threh3;						//Utouch ֭
int CL,t,a,b,TCH,cmpresult,tmrbcnt;
signed int sum,sum1,ADtemp10,ADtemp100,LED,ADCData,c,average,average1;//ADC
float gain,temp,tempp,temploop,temp1,Tos,showTemp;				//ū׭p
unsigned int unth0,unth1,unth2,unth3,th0,th1,th2,th3;
int ok;													//P_
int value_buf[16];	//TPS0 buffer -
int value_buf1[16];	//TPS1 buffer +	

int ADC_Array[2];
int i,ADCData_Chopper;			
/*----------------------------------------------------------------------------*/
/* Constant value definition                                                  */
/*----------------------------------------------------------------------------*/
unsigned char seg[]=
{
    seg_a+seg_b+seg_c+seg_d+seg_e+seg_f, // char "0"
    seg_b+seg_c,                         // char "1"
    seg_a+seg_b+seg_d+seg_e+seg_g,       // char "2"
    seg_a+seg_b+seg_c+seg_d+seg_g,       // char "3"
    seg_b+seg_c+seg_f+seg_g,             // char "4"
    seg_a+seg_c+seg_d+seg_f+seg_g,       // char "5"
    seg_a+seg_c+seg_d+seg_e+seg_f+seg_g, // char "6"
    seg_a+seg_b+seg_c,                   // char "7"
    seg_a+seg_b+seg_c+seg_d+seg_e+seg_f+seg_g,  // char "8"
    seg_a+seg_b+seg_c+seg_d+seg_f+seg_g, // char "9"
    seg_a+seg_b+seg_c+seg_e+seg_f+seg_g, // char "A"
    seg_c+seg_d+seg_e+seg_f+seg_g,       // char "b"
    seg_a+seg_d+seg_e+seg_f,             // char "C"
    seg_b+seg_c+seg_d+seg_e+seg_g,       // char "d"
    seg_a+seg_d+seg_e+seg_f+seg_g,       // char "E"
    seg_a+seg_e+seg_f+seg_g				 // char "F" 	
};            

/*----------------------------------------------------------------------------*/
/* Function prototype declaration                                             */
/*----------------------------------------------------------------------------*/

//------MISC Function declaration---------------
void User_Sample_Init(void);
void Delay(unsigned int num);
void PowerOn_Init_Go(void);
void Enter_SLEEP_Mode(void);
void On_Mode_Display(void);
void Key_In_Process(void);
//------ADC Function declaration----------------
void ADC_Init(void);

//------GPIO Function declaration---------------

//------TIMER Function declaration--------------

//------LCD Function declaration----------------
void LCD_Init(void);
void LCD_DATA_DISPLAY(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY1(unsigned int LcdBuffer);
void RAM2LCD(unsigned char *Buffer_Adr );
void ClearLCDframe(void);
void DisplayHYcon(void);

void Ini_Touch(void);
void Initial_ALL(void);
void touch_ct(void);
void ScanKey4(unsigned int TCH);
void User_Sample_Process(void);
void AD(void);	//TPS0 buffer -
void temp_Process(void);
void temp_ct(void);

/*----------------------------------------------------------------------------*/
/* Function Name: User_Sample_Init                                            */
/* Description  : Sample code Initialization Subroutines                      */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void User_Sample_Init(void)
{
    SYS_DisableGIE();                           //Disable Global Interrupt.

//------Sys. clock setting----------------------
    DrvCLOCK_SelectIHOSC( TRIM_HAO4MHZ );       //Select HAO= 4MHz.
    DrvCLOCK_EnableHighOSC(E_INTERNAL, 60);     //Enable HAO.
    DrvCLOCK_SelectMCUClock(0, 0);              //Select MCUCKS= HS_CK/1.

//------MISC. system initial--------------------
    LCD_Init();
    UserFlag0._byte = 0;
//------Power on initial going------------------
//Beep tone on & LCD display HYcon SCALE about 1Sec.

    DisplayHYcon();			   //bin
    UserFlag0.b_InitGo_Flag = TRUE;
}


void User_Sample_Process(void)
{
    if(t==1)					//(t=1NTMAwiJ_)
    {
        t=0;					//CPU
        //pmu_00=0x03031b1b;	//}Ҥ\(}touch\)
        pmu_00=0x03031b1a;		//}Ҥ\(}touch\)
        //cmp_00=0x13c3c;
        cmp_00=0xff0f;
        //cmp_04=0x101d3d3;
        cmp_04=0xff01ff03;
		
        clk_00=0xff01;			//}Ұt
        //clk_08=0xff4c;
        clk_08=0xffcc;		
        TCH=0;
	    //Delay(0x5000);
		
    }
    t=0;
}


void Key_In_Process(void)
{
        ScanKey4(TCH);			//ytouch1O_QUAtouch1QULED+1
        if(LED==1)
        {
			DrvLCD_DisplayMode( E_LCD_NORMAL );
            DrvLCD_VLCDTrim( 3 );
			
            while(1)
            {								
				
                if(LED==15)					//tocuh1ɶƫLED[15ɡA}ūܡAAiJٹqA
                {
                    LED=0;
                    ClearLCDframe();
                    DrvLCD_DisplayMode( E_LCD_PIXELOFF );       //All LCD off.
                    DrvLCD_VLCDMode( E_VLCD_DISABLE );          //close VLCD.
                    while( (inw(0x41B00) & (1<<IDF) ) == 0);    //Wait LCD Idle, IDF= 20.
					Enter_SLEEP_Mode();					
					break;
                }

                TCH=3;
                ScanKey4(TCH);			//ūܤUApGtouch4UAiJtouchեҦ(touch4U LED=10000)
                if(c==-15)
                {
                    touch_ct();			//Istouchեt{
                }
                TCH=2;
                ScanKey4(TCH);			//touch2UɡALED|1ALED-15ɡAiJū׮ե
                if(c==15)
                {
                    temp_ct();			//Isū׮եƵ{
                }
                //Delay(0x1000);
                TCH=0;
                ScanKey4(TCH);
				temp_Process();
            }
        }	
}

void temp_Process(void)
{
	DrvADC_Enable();				//}ADC\
    AD();							//ADCƵ{	
	gain=(273.15+tempp)/temp;			//ū״
	temploop=(gain*showTemp)-273.15;
	temploop*=10;
	LCD_DATA_DISPLAY1(temploop);	//ܲ{bū

}




void temp_ct(void)								//ū׮եƵ{
{
	AD();
	LCD_DATA_DISPLAY(showTemp);
	Delay(0xFFF0);
	Delay(0xFFF0);
    c=0;
	temp=showTemp;						//ADC
    LED=tempp;									//]w{bū
    while(1)
    {
        LCD_DATA_DISPLAY(LED);
        Delay(0xA000);
        TCH=0;
        ScanKey4(TCH);					//touch1=ūפWɤ@
        TCH=1;
        ScanKey4(TCH);					//touch2=ūפU@
        TCH=2;
        ScanKey4(TCH);					//touch3Tw
        if(c==3)
        {
            ClearLCDframe();					//MLCD
            c=0;
            tempp=LED;							//N]wȩJū׹BȦs
            DrvADC_DisableInt();				//ADC_
            DrvTIMER_DisableInt(E_TMA);			//TMA_
            DrvFlash_Burn_Word(0xA014,0x8000,0x1110);	//NP_O_եLμƭȿNJFlash
            DrvFlash_Burn_Word(0xA018,0x8000,tempp);	//NեȿNJFlash
            DrvFlash_Burn_Word(0xA01C,0x8000,temp);		//ADC
            Delay(0xff00);
            DrvTIMER_EnableInt(E_TMA);			//}TMA_
            DrvADC_EnableInt();					//}_ADC_
            LED=0;
            break;
        }
    }
}

void AD(void)									//TPS0Ƶ{
{

	while(ADfinish)									//ADC_OK=1
	{
		ADfinish=0;
		ADtemp10=ADCData;
		//ok=0;
		//ADtemp10=(ADCData>>14);
		value_buf[11]=value_buf[10];
		value_buf[10]=value_buf[9];
		value_buf[9]=value_buf[8];
		value_buf[8]=value_buf[7];				//ưoiBz
		value_buf[7]=value_buf[6];
		value_buf[6]=value_buf[5];
		value_buf[5]=value_buf[4];
		value_buf[4]=value_buf[3];
		value_buf[3]=value_buf[2];
		value_buf[2]=value_buf[1];
		value_buf[1]=ADtemp10;
		sum=0;
		for(t=9; t>5; t--)
		{
			sum+=value_buf[t];
		}
		average=((sum)>>2);
	}
	if(average<0)
	{
		average*=-1;
	}
	showTemp=average;
}



/*----------------------------------------------------------------------------*/
/* Function Name: PowerOn_Init_Go                                             */
/* Description  : Initial all user tasks (likes LCD, ADC for scale etc),      */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void PowerOn_Init_Go(void)
{
    Ini_Touch();
	ADC_Init();
    Initial_ALL();
    a=ReadWord(0xA014);					//P_ū׬O_QեLApGQեLFlash
    if(a==0x1110)
    {
        temp=ReadWord(0xA01C);
        tempp=ReadWord(0xA018);
    }
    else								//pGP_SեLA]w
    {
        temp=6047;
		//temp=5797;
        tempp=25;
    }

    a=ReadWord(0xA000);					//P_touchO_QեLApGQեLFlash
    if(a==0x5566)
    {
        threh0=ReadWord(0xA004);
        threh1=ReadWord(0xA008);
        threh2=ReadWord(0xA00c);
        threh3=ReadWord(0xA010);
    }
    else								//pGP_SեLA]w
    {
        touch_ct();

    }
	
	DrvADC_Enable();				//}ADC\
	
	for(i=0;i<=1;i++)
	 	{
	 	    switch (i)
	 	    {
	 	     case 0:  //wgĤ@
	 	     while(!ADfinish);  //if ADfinish=0, stop at here, until enter ADC INT
	 	     ADfinish=0;
	 	     ADC_Array[0]=ADCData;
	 	     DrvADC_Disable();
	 	     DrvADC_CombFilter(Disable);  //Disable CombFilter
	 	     //DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);
			 DrvADC_SetADCInputChannel(TPS0,TPS1);
	 	     DrvADC_Enable();
	 	     DrvADC_CombFilter(Enable);  //Disable CombFilter
	 	     DrvADC_ClearIntFlag();
			 DrvADC_EnableInt();
	 	     while(!ADfinish);  //if ADfinish=0, stop at here
	 	     break;

	 	     case 1:  //wgĤG
	 	     ADfinish=0;
	 	     ADC_Array[1]=ADCData;//>>16;
	 	     DrvADC_Disable();
	 	     DrvADC_CombFilter(Disable);  //Disable CombFilter
	 	     ADCData_Chopper=(ADC_Array[0]-ADC_Array[1])>>1;	//divider by 2
	 	     
	 	     //DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);
			 DrvADC_SetADCInputChannel(TPS1,TPS0);
	 	     DrvADC_Enable();
	 	     DrvADC_CombFilter(Enable);  //Disable CombFilter
	 	     DrvADC_ClearIntFlag();
	 	     DrvADC_EnableInt();
	 	     while(!ADfinish);	 //if ADfinish=0, stop at here
	 	     break;
	 	    }
	 	}
	
	DrvADC_Disable();		
	
	for(i=0; i<16; i++)
	{
		value_buf[i] = ADCData_Chopper;
	}
	
	for(t=4; t>0; t--)
		{
			sum+=value_buf[t];
		}
	average=((sum)>>2);	
	if(average<0)
	{
		average*=-1;
	}
	showTemp=average;
	
	
	gain=(273.15+tempp)/temp;		//ū״
	temploop=(gain*showTemp)-273.15;
	temploop*=10;
//	LCD_DATA_DISPLAY1(temploop);	//ܲ{bū
	
    UserFlag1._byte = 0;
    UserFlag0.b_InitGo_Flag = FALSE;
}





/*----------------------------------------------------------------------------*/
/* Function Name: Enter_SLEEP_Mode                                            */
/* Description  : Prepare to enter SLEEP mode.                                */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void Enter_SLEEP_Mode(void)
{
    pmu_00=0xff00ff00;			//N\(ٹq)
    cmp_00=0xff00;
    cmp_04=0xff00ff00;
    asm("NOP");
    ClearLCDframe();
    DrvLCD_DisplayMode( E_LCD_PIXELOFF );       //All LCD off.
    DrvLCD_VLCDMode( E_VLCD_DISABLE );          //close VLCD.
    while( (inw(0x41B00) & (1<<IDF) ) == 0);
    clk_08=0xff00ff0d;			//t_AϥΧCt(ٹq)
    Delay(0x100);
    clk_00=0xff00ff00;
    //DrvADC_Disable();           //disable ADC.

    //sys_04=0xff10;
    asm("syscall 11"); // idle = 11
    //asm("standby 0");
    asm("NOP");
    //DrvADC_Disable();				//ADC\(ٹq)
}


/*----------------------------------------------------------------------------*/
/* Function Name: Delay()                                                     */
/* Description  : Software delay subroutines.                                 */
/* Arguments    : unsigned int num.                                           */
/* Return Value : None.                                                       */
/* Remark       : num= 10,   delay time= 18u S @4MH HAO, 3V.                  */
/*              : num= 100,  delay time= 40u S @4MH HAO, 3V.                  */
/*              : num= 1000, delay time= 260uS @4MH HAO, 3V.                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
void Delay(unsigned int num)
{
    for( ; num >0; num-- )
        asm( "NOP" );
}

/******************************************************************************/
/* File Name    : user_GPIO.c                                                 */
/* Description  : This file implements the customer's GPIO function.          */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/


/******************************************************************************/
/* File Name    : user_ADC.c                                                  */
/* Description  : This file implements the customer's ADC function.           */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Function Name: ADC_Init                                                    */
/* Description  : ADC Initialization Subroutines                              */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void ADC_Init(void)
{
	unsigned int i;
#if (1)
    //set ADC input pin
//    DrvADC_PInputChannel( TPS0 );     			//set ADC positive input pin is TSP0.
//    DrvADC_NInputChannel( TPS1 );     			//set ADC negative input pin is TSN0.
	
	DrvADC_PInputChannel( TPS1 );     			//set ADC positive input pin is TSP1.
    DrvADC_NInputChannel( TPS0 );     			//set ADC negative input pin is TSN1.
	
    DrvADC_InputSwitch( OPEN );                 //set ADC input short-switch is open
    DrvADC_RefInputShort( OPEN );               //set VREF input short-switch is open
    DrvADC_Gain( ADC_PGA_Disable, ADC_ADGN_1 ); //set ADC  GAIN is PGA * ADGN = 1x1 = 1.

    //set ADC DC offset
    DrvADC_DCoffset( 0 );                       //set ADC DC input offset is 0 VREF

    //set ADC input reference voltage
    DrvADC_RefVoltage ( VDDA, VSSA );           //set VREF positive input pin(REFP) is VDDA, negative input pin(REFN) is VSSA.
    DrvADC_FullRefRange( 1 );                   //set VREF gain = 1/2 VREF= 2.4V/2= 1.2V
//  DrvADC_RefVoltage ( REF_BUFFER_OUT, VSSA ); //set VREF positive input pin(REFP) is REFO_I, negative input pin(REFN) is VSSA.
//  DrvADC_FullRefRange( 0 );                   //set VREF gain = 1 VREF= 1.2V

    //set ADC comb filter
    DrvADC_OSR( 0 );                            //set OSR= ADCK/32768 = (4MHz/12)/32768 = 10 sps.
    //DrvADC_OSR( 1 );                            //set OSR= ADCK/16384 = (4MHz/12)/16284 = 20 sps.
    DrvADC_CombFilter( 1 );                     //enable Comb filter.

    //set ADC clock
    DrvADC_ClkEnable( 1,1 );                    //set ADC CLOCK ADCK = HS_CK/12 = 2MHz/12 = 333KHz  & rising edge is high.

    //set VDDA voltage
    DrvPMU_VDDA_LDO_Ctrl( 3 );                  //enable adjustable LDO mode.
    DrvPMU_VDDA_Voltage( 0 );                   //set VDDA =2.4V

    //set VREF.
	DrvPMU_BandgapEnable();                     //band gap voltage
	DrvPMU_REFO_Enable();                       //enable REFO 1.2V
    DrvPMU_AnalogGround( 1 );                   //set analog enable buffer and use internal source
    DrvPMU_LDO_LowPower(0);						// bin  VDD LDO with low power control.
	Delay( 0x1000 );

    //set ADC interrupt
    DrvADC_ClearIntFlag();                      //clear ADC interrupt flag.
    DrvADC_EnableInt();                         //enable ADC interrupt.
    DrvADC_Enable();                            //enable ADC and start ADC.
	
	
	DrvADC_CombFilter( 0 );                 //reset !
	DrvADC_CombFilter( 1 );                 //enable !
	for(i=0; i<16; i++)
	{
		value_buf[i] = 0;
	}
	
	ADC_Count=0;
	ADfinish=0;
	ADCData_Chopper=0;
	ok=0;
	for(i=0;i<=1;i++)
	{
		ADC_Array[i]=0;
		ADC_Array[i]=0;
	}
	
	
	
	//DrvADC_Disable();		
	
#endif
}



/******************************************************************************/
/* File Name    : user_TIMER.c                                                */
/* Description  : This file implements the customer's TIMER unction.          */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/


/******************************************************************************/
/* File Name    : user_LCD.c                                                  */
/* Description  : This file implements the customer's LCD function.           */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Function Name: LCD_Init                                                    */
/* Description  : LCD Initialization Subroutines                              */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       : 1. LCD working@ 4COM x 36SEG, VLCD= from charge pump 2.93V. */
/*              : 2. Charge pump's clock from HS_CK/16= 4M/16= 250KHz).       */
/*              : 3. LCD CLK(LCK) from (HS_CK/64)/9/16= 4M/9216= 434Hz.       */
/*              :    so LCD frame Freq. = 434Hz/(4x2)= 54Hz.                  */
/*----------------------------------------------------------------------------*/
void LCD_Init(void)
{

    clk_10 = 0x40404B4B;                        //Set LCK= (HS_CK/64)/9/16= (HAO/64)/9/16= (4MHz/64)/144= 434Hz & charge pump clock = HS_CK/16.
    DrvLCD_VLCDMode( E_VLCD27 );
    DrvLCD_VLCDTrim( 3 );                       //Trim VLCD as 2.93V.
    DrvLCD_LcdDuty ( E_LCD_DUTY4 );             //enable LCD@1/4 duty.

    DrvLCD_IOMode( 5, 0xFF );                   //Set SEG1/0 as LCD mode.
    DrvLCD_IOMode( 0, 0xFF );                   //Set PT6(SEG2 ~SEG9 ) as LCD mode.
    DrvLCD_IOMode( 1, 0x07 );                   //Set PT7(SEG10~SEG12) as LCD mode.
//    DrvLCD_IOMode( 1, 0xFF );                   //Set PT7(SEG10~SEG17) as LCD mode.
//    DrvLCD_IOMode( 2, 0xFF );                   //Set PT8(SEG18~SEG25) as LCD mode.
//    DrvLCD_IOMode( 3, 0xFF );                   //Set PT9(SEG26~SEG33) as LCD mode.
//    DrvLCD_IOMode( 4, 0xFF );                   //Set PT10(SEG34~SEG35) as LCD mode.
    DrvLCD_LCDBuffer( ENABLE );                 //enable LCD working.
    DrvLCD_DisplayMode( E_LCD_NORMAL );         //LCD at normal mode.
//    LCD_RAM_Clear( SEG_BUF_SIZE );
    ClearLCDframe();
}

/*--------------------------------------------------------------------------*/
/* Clear LCD RAM Data                                                       */
/*--------------------------------------------------------------------------*/
void ClearLCDframe(void)
{
	int i=0;
	for(i=0; i<18; i++)
	{
		DisplayBuffer[i]=0x00;
	}
	RAM2LCD( DisplayBuffer );
}



/*----------------------------------------------------------------------------*/
/* Display HYcon Char                                                         */
/*----------------------------------------------------------------------------*/
void DisplayHYcon(void)
{
	DisplayBuffer[0]=0x00;
	DisplayBuffer[1]=Char_H;
	DisplayBuffer[2]=Char_Y;
	DisplayBuffer[3]=Char_c;
	DisplayBuffer[4]=Char_o;
	DisplayBuffer[5]=Char_n;
	DisplayBuffer[6]=0x00;
	DisplayBuffer[7]=0x00;
	DisplayBuffer[8]=0x00;
	RAM2LCD( DisplayBuffer );
}


/*----------------------------------------------------------------------------*/
/* Display RAM Data                                                           */
/*----------------------------------------------------------------------------*/
void LCD_DATA_DISPLAY(unsigned int LcdBuffer)
{
	DisplayBuffer[0]=0x00;
	DisplayBuffer[1]=0x00;
	DisplayBuffer[2]=0x00;
	DisplayBuffer[3]=0x00;
	DisplayBuffer[4]=0x00;
	DisplayBuffer[5]=0x00;
	int i;
	for(i=5; i>=0; i--)
	{
		DisplayBuffer[i]=seg[LcdBuffer%10];
		LcdBuffer=LcdBuffer/10;
	}
	RAM2LCD( DisplayBuffer );
}

/*----------------------------------------------------------------------------*/
/* Display RAM Data                                                           */
/*----------------------------------------------------------------------------*/
void LCD_DATA_DISPLAY1(unsigned int LcdBuffer)
{
	DisplayBuffer[0]=0x00;
	DisplayBuffer[1]=0x00;
	DisplayBuffer[2]=0x00;
	DisplayBuffer[3]=0x00;
	DisplayBuffer[4]=0x00;
	DisplayBuffer[5]=0x00;
	int i;
	for(i=5; i>=0; i--)
	{
		DisplayBuffer[i]=seg[LcdBuffer%10];
		LcdBuffer=LcdBuffer/10;
	}
	
	DisplayBuffer[4]=DisplayBuffer[4]|seg_h;		//pI
	RAM2LCD( DisplayBuffer );
}

/*----------------------------------------------------------------------------*/
/* Function Name: RAM2LCD                                                     */
/* Description  : RAM buffer data transfer to LCD RAM                         */
/* Arguments    : unsigned char *Buffer_Adr => buffer pointer address.        */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void RAM2LCD( unsigned char *Buffer_Adr )
{
	unsigned char buf_idx;

	for(buf_idx=0; buf_idx<SEG_BUF_SIZE; buf_idx++)
	{
		DrvLCD_WriteData ( buf_idx, *Buffer_Adr );
		Buffer_Adr++;
	}
}


void Initial_ALL(void)
{
    pio1_1=0xff00ff00;		//PT1 	0x40800    //TOSΪ}
    pio1_2=0xff00ff00;		//		0x40804
    pio1_3=0x00;			//		0x40808
    pio2_1=0xff00ff03;		//PT2	0x40810
    pio2_2=0xff00ff03;		//		0x40814

    LED=0;
    t=0;
    TCH=0;
    c=0;

    DrvTMA_Open(9,1);                   			//TimerA Overflow
													//9:taclk/1024/32;TMRDV=32
													//00:HS_CK
    DrvTIMER_ClearIntFlag(E_TMA);       			//Clear Timer A interrupt flag
    DrvTIMER_EnableInt(E_TMA);          			//Timer A interrupt enable

    SYS_EnableGIE(4,0x06 );	                  		//Enable GIE
}


void Ini_Touch(void)
{
    DrvCMP_Enable();                                // CMP enable
    DrvCMP_Open(1,1,1);                             // CMP open
    DrvCMP_PInput(0);                               // Comparator positive input  CH1
    DrvCMP_NInput(3);                               // Comparator negative input  RLO
    DrvCMP_RLO_refV(2,1);							// RLO Ref = VDD3V , CPRL=1
    DrvCMP_DisableNonOverlap();						// disable Nonoverlap
    DrvCMP_RLO_Ctrl(0,1);							// 0 , uCPDM=1 (enable) 
    DrvCMP_InputSwitch(1);							// CPIS short
    DrvCMP_InputSwitch(0);							// CPIS open
    DrvCMP_RLO_Ctrl(1,0);							// 1/16 (CPRLH V CPRLL) uCPDM=0 (disable)
    DrvTMB_ClearTMB();								// clear TimerB
    DrvCLOCK_SelectIHOSC(0x00);						// HAO =2MHz
    DrvCLOCK_SelectMCUClock(0,0);                   // select MCU clock as HS_CK,div1
    DrvTMBC_Clk_Source(1,0);                		// TimerB Clock enable pre_scale 1 (LS_ck)
    DrvTMB_Open(E_TMB_MODE0,E_TMB_CMP_HIGH,0xffff); // TimerB overflow 0xffff-> CMP High Level trigger
    DrvTMB_ClearTMB();								// clear TimerB
    DrvPMU_VDDA_Voltage(E_VDDA2_4);					// VDDA=2.4V
    DrvPMU_VDDA_LDO_Ctrl(E_LDO);					// VDDA LDOAVDDAiտXAVDASMw
    DrvPMU_BandgapEnable();							// ebable bandgap
    DrvPMU_REFO_Enable();							// REFO enable
    DrvPMU_AnalogGround(Enable);                    //ADC analog ground source selection.
													//1 : Enable buffer and use internal source(need to work with ADC)
    DrvPMU_LDO_LowPower(Enable);                    //VDD LDO with low power control.//0 : Normal;1 : Low power
    Delay(0x1000);
}

void touch_ct(void)								//touch keyեƵ{
{
    int z,y;

    LCD_DATA_DISPLAY(888888);
    unth0=0;									//touch1 untouch(8)
    for(z=0; z<8; z++)
    {
        TCH=0;
        ScanKey4(TCH);
        unth0+=tmrbcnt;
        Delay(0xFFF);
    }
    unth0=unth0>>3;
    LCD_DATA_DISPLAY(777777);
    unth1=0;									//touch2 untouch(8)
    for(z=0; z<8; z++)
    {
        TCH=1;
        ScanKey4(TCH);
        unth1+=tmrbcnt;
        Delay(0xFFF);
    }
    unth1=unth1>>3;
    LCD_DATA_DISPLAY(666666);
    unth2=0;									//touch3 untouch(8)
    for(z=0; z<8; z++)
    {
        TCH=2;
        ScanKey4(TCH);
        unth2+=tmrbcnt;
        Delay(0xFFF);
    }
    unth2=unth2>>3;
    LCD_DATA_DISPLAY(555555);
    unth3=0;									//touch4 untouch(8)
    for(z=0; z<8; z++)
    {
        TCH=3;
        ScanKey4(TCH);
        unth3+=tmrbcnt;
        Delay(0xfff);
    }
    unth3=unth3>>3;

    LCD_DATA_DISPLAY(994444);
    th0=0;										//touch1 touch(8)
    y=8;
    while(y)
    {
        TCH=0;
        ScanKey4(TCH);
        if(tmrbcnt<435)
        {
            y--;
            th0+=tmrbcnt;
        }
    }
    th0=th0>>3;
    LCD_DATA_DISPLAY(993333);
    th1=0;										//touch2 touch(8)
    y=8;
    while(y)
    {
        TCH=1;
        ScanKey4(TCH);
        if(tmrbcnt<220)
        {
            y--;
            th1+=tmrbcnt;
        }
    }
    th1=th1>>3;
    LCD_DATA_DISPLAY(992222);
    th2=0;										//touch3 touch(8)
    y=8;
    while(y)
    {
        TCH=2;
        ScanKey4(TCH);
        if(tmrbcnt<180)
        {
            y--;
            th2+=tmrbcnt;
        }
    }
    th2=th2>>3;
    LCD_DATA_DISPLAY(991111);
    th3=0;										//touch4 touch(8)
    y=8;
    while(y)
    {
        TCH=3;
        ScanKey4(TCH);
        if(tmrbcnt<180)
        {
            y--;
            th3+=tmrbcnt;
        }
    }
    th3=th3>>3;
    threh0=unth0-(((unth0-th0)*3)/4);				//pե
    threh1=unth1-(((unth1-th1)*3)/4);
    threh2=unth2-(((unth2-th2)*3)/4);
    threh3=unth3-(((unth3-th3)*3)/4);
    LED=0;
    c=0;
    DrvADC_DisableInt();							//ADC_
    DrvTIMER_DisableInt(E_TMA);						//TMA_
    DrvFlash_Burn_Word(0xA000,0x8000,0x5566);		//NP_O_եLέȡAsJFlach
    DrvFlash_Burn_Word(0xA004,0x8000,threh0);		//NեȦsJFlash
    DrvFlash_Burn_Word(0xA008,0x8000,threh1);
    DrvFlash_Burn_Word(0xA00c,0x8000,threh2);
    DrvFlash_Burn_Word(0xA010,0x8000,threh3);
    Delay(0x8000);
    DrvTIMER_EnableInt(E_TMA);						//}TMA_
    DrvADC_EnableInt();								//}ADC_
}


void ScanKey4(unsigned int TCH)						//touch keyƵ{
{
    CL=TCH;
    pio1_1=0x0100;
    DrvTMB_ClearTMB();
    DrvCMP_EnableNonOverlap(CL);
    cmpresult=DrvCMP_ReadData();
    while(cmpresult==1)
    {
        cmpresult=DrvCMP_ReadData();
    }
    tmrbcnt=DrvTMB_CounterRead();//TMB				//P_RqɶO_C֭
    switch(CL)
    {
    case 0 :
        if(tmrbcnt<=threh0)
        {
            LED++;
        }
        break;
    case 1 :
        if(tmrbcnt<=threh1)
        {
            LED--;
        }
        break;
    case 2 :
        if(tmrbcnt<=threh2)
        {
            c++;
        }
        break;
    case 3 :
        if(tmrbcnt<=threh3)
        {
            c--;
        }
        break;
    default:
        LED=0;
    }
    pio1_1=0x0101;
    pio1_2=0x0100;

}


/*----------------------------------------------------------------------------*/
/* End Of File                                                                */
/*----------------------------------------------------------------------------*/
